From 82df10f06269f584076dda9b1ce7280bb01e7363 Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Wed, 3 Nov 2021 16:01:53 +0100
Subject: [PATCH v2] Remove non-OpenSSL support from pgcrypto

Discussion: https://www.postgresql.org/message-id/flat/0b42f1df-8cba-6a30-77d7-acc241cc88c1%40enterprisedb.com
---
 contrib/Makefile                    |    5 +-
 contrib/pgcrypto/Makefile           |   73 +-
 contrib/pgcrypto/blf.c              |  499 ----
 contrib/pgcrypto/blf.h              |   46 -
 contrib/pgcrypto/imath.c            | 3588 ---------------------------
 contrib/pgcrypto/imath.h            |  445 ----
 contrib/pgcrypto/internal-sha2.c    |  206 --
 contrib/pgcrypto/internal.c         |  585 -----
 contrib/pgcrypto/pgp-mpi-internal.c |  304 ---
 contrib/pgcrypto/rijndael.c         |  677 -----
 contrib/pgcrypto/rijndael.h         |   59 -
 contrib/pgcrypto/rijndael.tbl       | 1138 ---------
 doc/src/sgml/pgcrypto.sgml          |  108 +-
 src/tools/msvc/Mkvcbuild.pm         |   39 +-
 src/tools/msvc/vcregress.pl         |    4 +-
 15 files changed, 37 insertions(+), 7739 deletions(-)
 delete mode 100644 contrib/pgcrypto/blf.c
 delete mode 100644 contrib/pgcrypto/blf.h
 delete mode 100644 contrib/pgcrypto/imath.c
 delete mode 100644 contrib/pgcrypto/imath.h
 delete mode 100644 contrib/pgcrypto/internal-sha2.c
 delete mode 100644 contrib/pgcrypto/internal.c
 delete mode 100644 contrib/pgcrypto/pgp-mpi-internal.c
 delete mode 100644 contrib/pgcrypto/rijndael.c
 delete mode 100644 contrib/pgcrypto/rijndael.h
 delete mode 100644 contrib/pgcrypto/rijndael.tbl

diff --git a/contrib/Makefile b/contrib/Makefile
index f27e458482..87bf87ab90 100644
--- a/contrib/Makefile
+++ b/contrib/Makefile
@@ -36,7 +36,6 @@ SUBDIRS = \
 		pg_stat_statements \
 		pg_surgery	\
 		pg_trgm		\
-		pgcrypto	\
 		pgrowlocks	\
 		pgstattuple	\
 		pg_visibility	\
@@ -52,9 +51,9 @@ SUBDIRS = \
 		vacuumlo
 
 ifeq ($(with_ssl),openssl)
-SUBDIRS += sslinfo
+SUBDIRS += pgcrypto sslinfo
 else
-ALWAYS_SUBDIRS += sslinfo
+ALWAYS_SUBDIRS += pgcrypto sslinfo
 endif
 
 ifneq ($(with_uuid),no)
diff --git a/contrib/pgcrypto/Makefile b/contrib/pgcrypto/Makefile
index c0b4f1fcf6..7fb59f51b7 100644
--- a/contrib/pgcrypto/Makefile
+++ b/contrib/pgcrypto/Makefile
@@ -1,48 +1,38 @@
 # contrib/pgcrypto/Makefile
 
-INT_SRCS = internal.c internal-sha2.c blf.c rijndael.c \
-		pgp-mpi-internal.c imath.c
-INT_TESTS = sha2
-
-OSSL_SRCS = openssl.c pgp-mpi-openssl.c
-OSSL_TESTS = sha2 des 3des cast5
-
 ZLIB_TST = pgp-compression
 ZLIB_OFF_TST = pgp-zlib-DISABLED
 
-CF_SRCS = $(if $(subst openssl,,$(with_ssl)), $(INT_SRCS), $(OSSL_SRCS))
-CF_TESTS = $(if $(subst openssl,,$(with_ssl)), $(INT_TESTS), $(OSSL_TESTS))
 CF_PGP_TESTS = $(if $(subst no,,$(with_zlib)), $(ZLIB_TST), $(ZLIB_OFF_TST))
 
-SRCS = \
-	$(CF_SRCS) \
-	crypt-blowfish.c \
-	crypt-des.c \
-	crypt-gensalt.c \
-	crypt-md5.c \
-	mbuf.c \
-	pgcrypto.c \
-	pgp-armor.c \
-	pgp-cfb.c \
-	pgp-compress.c \
-	pgp-decrypt.c \
-	pgp-encrypt.c \
-	pgp-info.c \
-	pgp-mpi.c \
-	pgp-pgsql.c \
-	pgp-pubdec.c \
-	pgp-pubenc.c \
-	pgp-pubkey.c \
-	pgp-s2k.c \
-	pgp.c \
-	px-crypt.c \
-	px-hmac.c \
-	px.c
+OBJS = \
+	$(WIN32RES) \
+	crypt-blowfish.o \
+	crypt-des.o \
+	crypt-gensalt.o \
+	crypt-md5.o \
+	mbuf.o \
+	openssl.o \
+	pgcrypto.o \
+	pgp-armor.o \
+	pgp-cfb.o \
+	pgp-compress.o \
+	pgp-decrypt.o \
+	pgp-encrypt.o \
+	pgp-info.o \
+	pgp-mpi.o \
+	pgp-mpi-openssl.o \
+	pgp-pgsql.o \
+	pgp-pubdec.o \
+	pgp-pubenc.o \
+	pgp-pubkey.o \
+	pgp-s2k.o \
+	pgp.o \
+	px-crypt.o \
+	px-hmac.o \
+	px.o
 
 MODULE_big	= pgcrypto
-OBJS = \
-	$(SRCS:.c=.o) \
-	$(WIN32RES)
 
 EXTENSION = pgcrypto
 DATA = pgcrypto--1.3.sql pgcrypto--1.2--1.3.sql pgcrypto--1.1--1.2.sql \
@@ -50,7 +40,7 @@ DATA = pgcrypto--1.3.sql pgcrypto--1.2--1.3.sql pgcrypto--1.1--1.2.sql \
 PGFILEDESC = "pgcrypto - cryptographic functions"
 
 REGRESS = init md5 sha1 hmac-md5 hmac-sha1 blowfish rijndael \
-	$(CF_TESTS) \
+	sha2 des 3des cast5 \
 	crypt-des crypt-md5 crypt-blowfish crypt-xdes \
 	pgp-armor pgp-decrypt pgp-encrypt $(CF_PGP_TESTS) \
 	pgp-pubkey-decrypt pgp-pubkey-encrypt pgp-info
@@ -77,12 +67,3 @@ SHLIB_LINK += $(filter -leay32, $(LIBS))
 # those must be at the end
 SHLIB_LINK += -lws2_32
 endif
-
-# Upstream uses a larger subset of C99.
-imath.o: CFLAGS+=$(PERMIT_DECLARATION_AFTER_STATEMENT)
-
-rijndael.o: rijndael.tbl
-
-rijndael.tbl:
-	$(CC) $(CPPFLAGS) $(CFLAGS) -DPRINT_TABS rijndael.c -o gen-rtab
-	./gen-rtab > rijndael.tbl
diff --git a/doc/src/sgml/pgcrypto.sgml b/doc/src/sgml/pgcrypto.sgml
index 648703cbc7..5906401145 100644
--- a/doc/src/sgml/pgcrypto.sgml
+++ b/doc/src/sgml/pgcrypto.sgml
@@ -44,9 +44,8 @@ <title><function>digest()</function></title>
     Standard algorithms are <literal>md5</literal>, <literal>sha1</literal>,
     <literal>sha224</literal>, <literal>sha256</literal>,
     <literal>sha384</literal> and <literal>sha512</literal>.
-    If <filename>pgcrypto</filename> was built with
-    <productname>OpenSSL</productname>, more algorithms are available, as
-    detailed in <xref linkend="pgcrypto-with-without-openssl"/>.
+    Moreover, any digest algorithm <productname>OpenSSL</productname> supports
+    is automatically picked up.
    </para>
 
    <para>
@@ -764,7 +763,7 @@ <title>cipher-algo</title>
     Which cipher algorithm to use.
    </para>
 <literallayout>
-Values: bf, aes128, aes192, aes256 (OpenSSL-only: <literal>3des</literal>, <literal>cast5</literal>)
+Values: bf, aes128, aes192, aes256, 3des, cast5
 Default: aes128
 Applies to: pgp_sym_encrypt, pgp_pub_encrypt
 </literallayout>
@@ -1163,98 +1162,16 @@ <title>Configuration</title>
    </para>
 
    <para>
-    When compiled with <productname>OpenSSL</productname>, there will be
-    more algorithms available. Also public-key encryption functions will
-    be faster as <productname>OpenSSL</productname> has more optimized
-    BIGNUM functions.
+    <filename>pgcrypto</filename> requires <productname>OpenSSL</productname>.
+    Otherwise, it will not be built or installed.
    </para>
 
-   <table id="pgcrypto-with-without-openssl">
-    <title>Summary of Functionality with and without OpenSSL</title>
-    <tgroup cols="3">
-     <thead>
-      <row>
-       <entry>Functionality</entry>
-       <entry>Built-in</entry>
-       <entry>With OpenSSL</entry>
-      </row>
-     </thead>
-     <tbody>
-      <row>
-       <entry>MD5</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>SHA1</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>SHA224/256/384/512</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>Other digest algorithms</entry>
-       <entry>no</entry>
-       <entry>yes (Note 1)</entry>
-      </row>
-      <row>
-       <entry>Blowfish</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>AES</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>DES/3DES/CAST5</entry>
-       <entry>no</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>Raw encryption</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>PGP Symmetric encryption</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-      <row>
-       <entry>PGP Public-Key encryption</entry>
-       <entry>yes</entry>
-       <entry>yes</entry>
-      </row>
-     </tbody>
-    </tgroup>
-   </table>
-
    <para>
     When compiled against <productname>OpenSSL</productname> 3.0.0 and later
     versions, the legacy provider must be activated in the
     <filename>openssl.cnf</filename> configuration file in order to use older
     ciphers like DES or Blowfish.
    </para>
-
-   <para>
-    Notes:
-   </para>
-
-   <orderedlist>
-    <listitem>
-     <para>
-      Any digest algorithm <productname>OpenSSL</productname> supports
-      is automatically picked up.
-      This is not possible with ciphers, which need to be supported
-      explicitly.
-     </para>
-    </listitem>
-   </orderedlist>
   </sect3>
 
   <sect3>
@@ -1401,21 +1318,6 @@ <title>Author</title>
       <entry>Solar Designer</entry>
       <entry>www.openwall.com</entry>
      </row>
-     <row>
-      <entry>Blowfish cipher</entry>
-      <entry>Simon Tatham</entry>
-      <entry>PuTTY</entry>
-     </row>
-     <row>
-      <entry>Rijndael cipher</entry>
-      <entry>Brian Gladman</entry>
-      <entry>OpenBSD sys/crypto</entry>
-     </row>
-     <row>
-      <entry>BIGNUM math</entry>
-      <entry>Michael J. Fromberger</entry>
-      <entry>dartmouth.edu/~sting/sw/imath</entry>
-     </row>
     </tbody>
    </tgroup>
   </informaltable>
diff --git a/src/tools/msvc/Mkvcbuild.pm b/src/tools/msvc/Mkvcbuild.pm
index 4362bd44fd..856fb7a2cc 100644
--- a/src/tools/msvc/Mkvcbuild.pm
+++ b/src/tools/msvc/Mkvcbuild.pm
@@ -440,7 +440,7 @@ sub mkvcbuild
 
 	if (!$solution->{options}->{openssl})
 	{
-		push @contrib_excludes, 'sslinfo', 'ssl_passphrase_callback';
+		push @contrib_excludes, 'sslinfo', 'ssl_passphrase_callback', 'pgcrypto';
 	}
 
 	if (!$solution->{options}->{uuid})
@@ -448,41 +448,6 @@ sub mkvcbuild
 		push @contrib_excludes, 'uuid-ossp';
 	}
 
-	# AddProject() does not recognize the constructs used to populate OBJS in
-	# the pgcrypto Makefile, so it will discover no files.
-	my $pgcrypto =
-	  $solution->AddProject('pgcrypto', 'dll', 'crypto', 'contrib/pgcrypto');
-	$pgcrypto->AddFiles(
-		'contrib/pgcrypto', 'pgcrypto.c',
-		'px.c',             'px-hmac.c',
-		'px-crypt.c',       'crypt-gensalt.c',
-		'crypt-blowfish.c', 'crypt-des.c',
-		'crypt-md5.c',      'mbuf.c',
-		'pgp.c',            'pgp-armor.c',
-		'pgp-cfb.c',        'pgp-compress.c',
-		'pgp-decrypt.c',    'pgp-encrypt.c',
-		'pgp-info.c',       'pgp-mpi.c',
-		'pgp-pubdec.c',     'pgp-pubenc.c',
-		'pgp-pubkey.c',     'pgp-s2k.c',
-		'pgp-pgsql.c');
-	if ($solution->{options}->{openssl})
-	{
-		$pgcrypto->AddFiles('contrib/pgcrypto', 'openssl.c',
-			'pgp-mpi-openssl.c');
-	}
-	else
-	{
-		$pgcrypto->AddFiles(
-			'contrib/pgcrypto', 'internal.c',
-			'internal-sha2.c',  'blf.c',
-			'rijndael.c',       'pgp-mpi-internal.c',
-			'imath.c');
-	}
-	$pgcrypto->AddReference($postgres);
-	$pgcrypto->AddLibrary('ws2_32.lib');
-	my $mf = Project::read_file('contrib/pgcrypto/Makefile');
-	GenerateContribSqlFiles('pgcrypto', $mf);
-
 	foreach my $subdir ('contrib', 'src/test/modules')
 	{
 		opendir($D, $subdir) || croak "Could not opendir on $subdir!\n";
@@ -795,7 +760,7 @@ sub mkvcbuild
 		}
 	}
 
-	$mf =
+	my $mf =
 	  Project::read_file('src/backend/utils/mb/conversion_procs/Makefile');
 	$mf =~ s{\\\r?\n}{}g;
 	$mf =~ m{SUBDIRS\s*=\s*(.*)$}m
diff --git a/src/tools/msvc/vcregress.pl b/src/tools/msvc/vcregress.pl
index fc826da3ff..e3a323b8bf 100644
--- a/src/tools/msvc/vcregress.pl
+++ b/src/tools/msvc/vcregress.pl
@@ -730,9 +730,7 @@ sub fetchTests
 			# configuration of the build
 
 			my $cftests =
-			  $config->{openssl}
-			  ? GetTests("OSSL_TESTS", $m)
-			  : GetTests("INT_TESTS",  $m);
+			  GetTests("OSSL_TESTS", $m);
 			my $pgptests =
 			  $config->{zlib}
 			  ? GetTests("ZLIB_TST",     $m)
-- 
2.33.1

